import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Icon } from '@teambit/evangelist.elements.icon';
import classNames from 'classnames';
import { useState, useEffect, useRef } from 'react';
import AnimateHeight from 'react-animate-height';
import { indentClass, indentStyle, TreeLayer, useTree } from '@teambit/design.ui.tree';
import { getName } from '../utils/get-name';
import styles from './scope-tree-node.module.scss';
export function ScopeTreeNode({ node, depth }) {
    const { isCollapsed, activePath } = useTree();
    const isActive = activePath?.startsWith(node.id);
    const initialOpen = isActive || !isCollapsed;
    const [open, toggle] = useState(initialOpen);
    const displayName = getName(node.id.replace(/\/$/, ''));
    const firstRun = useRef(true);
    useEffect(() => {
        const { current } = firstRun;
        if (current)
            return;
        if (isActive === true)
            toggle(true);
    }, [isActive]);
    useEffect(() => {
        const { current } = firstRun;
        if (current)
            return;
        toggle(!isCollapsed);
    }, [isCollapsed]);
    useEffect(() => {
        firstRun.current = false;
    }, []);
    const highlighted = !open && isActive;
    return (_jsxs("div", { children: [node.id && (_jsx("div", { className: classNames(indentClass, styles.scope, highlighted && styles.highlighted), onClick: () => toggle(!open), onKeyDown: (e) => {
                    if (e.key === 'Enter')
                        toggle(!open);
                }, role: "button", tabIndex: 0, children: _jsxs("div", { className: styles.left, children: [_jsx(Icon, { className: classNames(styles.arrow, !open && styles.collapsed), of: "fat-arrow-down" }), _jsx(Icon, { className: styles.arrow, of: "collection-full" }), _jsx("span", { className: styles.name, children: displayName })] }) })), _jsx(AnimateHeight, { height: open ? 'auto' : 0, children: _jsx("div", { style: indentStyle(depth + 1), className: classNames(styles.componentTree), children: node.children && _jsx(TreeLayer, { childNodes: node.children, depth: depth + 1 }) }) })] }));
}
//# sourceMappingURL=scope-tree-node.js.map